=== debian/watch ===
version=4
https://lkrg.org/download/lkrg-(.+).tar.gz
opts=pgpsigurlmangle=s/$/.sign/ https://lkrg.org/download/lkrg-(.+).tar.gz
